stages:
  - init
  - plan
  - apply
  - deploy

.tf_defaults:
  variables:
    TF_USERNAME: gitlab-ci-token
    TF_PASSWORD: ${CI_JOB_TOKEN}
    TF_ADDRESS: "https://gitlab.com/api/v4/projects/${CI_PROJECT_ID}/terraform/state/factory"

  image: registry.gitlab.com/aiyor/container_images/terraform:1.0.1
  before_script:
    - export TF_HTTP_ADDRESS="${TF_HTTP_ADDRESS:-${TF_ADDRESS}}"
    - export TF_HTTP_LOCK_ADDRESS="${TF_HTTP_LOCK_ADDRESS:-${TF_ADDRESS}/lock}"
    - export TF_HTTP_LOCK_METHOD="${TF_HTTP_LOCK_METHOD:-POST}"
    - export TF_HTTP_UNLOCK_ADDRESS="${TF_HTTP_UNLOCK_ADDRESS:-${TF_ADDRESS}/lock}"
    - export TF_HTTP_UNLOCK_METHOD="${TF_HTTP_UNLOCK_METHOD:-DELETE}"
    - export TF_HTTP_USERNAME="${TF_HTTP_USERNAME:-${TF_USERNAME}}"
    - export TF_HTTP_PASSWORD="${TF_HTTP_PASSWORD:-${TF_PASSWORD}}"
    - export TF_HTTP_RETRY_WAIT_MIN="${TF_HTTP_RETRY_WAIT_MIN:-5}"
  cache:
    key: tf_cache
    paths:
      - ${CI_PROJECT_DIR}/.terraform
      - ${CI_PROJECT_DIR}/.terraform.lock.hcl

tf_init:
  extends: .tf_defaults
  stage: init
  script:
    - terraform init
  rules:
    - when: manual

tf_plan:
  extends: .tf_defaults
  stage: plan
  script:
    - terraform plan -input=false -out=plan.cache
  rules:
    - when: manual
  artifacts:
    name: tf_plan
    paths:
      - plan.cache
    expire_in: "1 day"

tf_apply:
  extends: .tf_defaults
  stage: apply
  script:
    - terraform apply -input=false plan.cache
  rules:
    - when: manual
  dependencies:
    - tf_plan
  artifacts:
    when: on_success
    paths:
      - public
    expire_in: "1 day"

pages:
  stage: deploy
  script:
    - cp index.html public/
  artifacts:
    paths:
      - public
